package com.example.program;

import android.os.CountDownTimer;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.util.Random;

public class MainActivity extends AppCompatActivity {

    CountDownTimer timer_for_flash;
    CountDownTimer timer_for_click;
    CountDownTimer timer_flashing_red, timer_flashing_blue, timer_flashing_green, timer_flashing_yellow;
    int time_for_click = 10;
    int time_for_flash = 5;

    int score = 0;
    boolean red, blue, green, yellow = false;

    TextView tv_score, tv_time;
    Button b_blue, b_red, b_green, b_yellow, b_start;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        tv_score = (TextView) findViewById(R.id.tv_score);
        tv_time = (TextView) findViewById(R.id.tv_time);
        b_blue = (Button) findViewById(R.id.b_blue);
        b_red = (Button) findViewById(R.id.b_red);
        b_green = (Button) findViewById(R.id.b_green);
        b_yellow = (Button) findViewById(R.id.b_yellow);

        b_start = (Button) findViewById(R.id.b_start);

        b_start.setEnabled(true);
        b_red.setEnabled(false);
        b_blue.setEnabled(false);
        b_green.setEnabled(false);
        b_yellow.setEnabled(false);

        timer_for_flash = new CountDownTimer(10000, 5000) {
            @Override
            public void onTick(long millisUntilFinished) {
                final int random = new Random().nextInt(4);
                if (random == 0) {
                    timer_flashing_red.start();
                }
                else if (random == 1) {
                    timer_flashing_yellow.start();
                }
                else if (random == 2) {
                    timer_flashing_green.start();
                }
                else if (random == 3) {
                    timer_flashing_blue.start();
                }
            }

            @Override
            public void onFinish() {
                b_start.setEnabled(false);
                b_red.setEnabled(true);
                b_blue.setEnabled(true);
                b_green.setEnabled(true);
                b_yellow.setEnabled(true);
            }

        };
        b_red.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (red) {
                    score++;
                    tv_score.setText("Score: " + score);
                    timer_for_flash.start();
                }
            }
        });

        b_blue.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick (View v){
                if (blue) {
                    score++;
                    tv_score.setText("Score: " + score);
                    timer_for_flash.start();
                }
            }
            }) ;

        b_yellow.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick (View v){
                if (yellow) {
                    score++;
                    tv_score.setText("Score: " + score);
                    timer_for_flash.start();
                }
            }
        }) ;

        b_green.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick (View v){
                if (green) {
                    score++;
                    tv_score.setText("Score: " + score);
                    timer_for_flash.start();
                }
            }
        }) ;

        b_start.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                timer_for_flash.start();
            }
        });

        timer_flashing_red = new CountDownTimer(2000, 200) {
            @Override
            public void onTick(long millisUntilFinished) {
                b_red.setBackgroundColor(0xFFFF0000);
                red = true;
            }

            @Override
            public void onFinish() {
                b_red.setBackgroundColor(0xFF000000);
            }
        };


        timer_flashing_yellow = new CountDownTimer(2000, 200) {
            @Override
            public void onTick(long millisUntilFinished) {
                b_yellow.setBackgroundColor(0xFFFF00FF);
                yellow = true;

            }

            @Override
            public void onFinish() {
                b_yellow.setBackgroundColor(0xFF000000);
            }
        };


        timer_flashing_green = new CountDownTimer(2000, 200) {
            @Override
            public void onTick(long millisUntilFinished) {
                b_green.setBackgroundColor(0xFF00FF00);
                green = true;

            }

            @Override
            public void onFinish() {
                b_green.setBackgroundColor(0xFF000000);
            }
        };


        timer_flashing_blue = new CountDownTimer(2000, 200) {
            @Override
            public void onTick(long millisUntilFinished) {
                b_blue.setBackgroundColor(0xFF0000FF);
                blue = true;

            }

            @Override
            public void onFinish() {
                b_blue.setBackgroundColor(0xFF000000);
            }
        };

    }

}
